#COMPILE EXE
GLOBAL Lat#, Lon#' , Message$

%UPort = 16004
MACRO FUNCTION DottedIP(ip)
    MACROTEMP x
    LOCAL x AS BYTE PTR
    x = VARPTR(ip)
END MACRO = USING$("#_.#_.#_.#", @x, @x[1], @x[2], @x[3])

FUNCTION PBMAIN () AS LONG
    LOCAL ip     AS LONG      ' This machines IP address
    LOCAL hUdp   AS LONG      ' UDP file number
    LOCAL Buffer AS STRING    ' UDP data received
    LOCAL ipAddr AS LONG      ' IP address of sending machine
    LOCAL ipPort AS LONG      ' UDP Port of sending machine to reply to

    PRINT : PRINT : PRINT
    PRINT "Generates .KML and .CSV files for plotting on Google Earth."
    PRINT "Reads UDP Mesages sent from WSJT-X in real time
    PRINT

    ' Get this machine's IP address
    HOST ADDR TO ip
    HOST NAME TO hn$
    COLOR 8
    PRINT "Host name " & hn$
    PRINT
     ' Open a specific UDP/IP port with a 20 second timeout
    hUdp = FREEFILE
    UDP OPEN PORT %UPort AS hUdp TIMEOUT 20000
    IF ERR THEN BEEP : EXIT FUNCTION

    ' We opened the UDP/IP port Ok, so inform the user
    PRINT "Listening for broadcasts to " + DottedIP(ip) + ":" + _
      FORMAT$(%UPort) + "..."
    COLOR 7

    PRINT

    tim$ = TIME$    'Use system date/time for file naming
    dat$ = DATE$
    f2a$ = MID$(dat$, 9,2)&  MID$(DAT$, 1,2) & MID$(DAT$, 4,2) & "_" & MID$(tim$, 1 , 2) & MID$(tim$,4,2) & ".KML"

    PRINT "Destination (.KML) file        [" & f2a$ & "]     ";
    INPUT f2$
    f2$ = UCASE$(f2$)
    IF f2$ = "" THEN f2$ = f2a$
    IF INSTR(f2$ , ".") = 0 THEN f2$ = f2$ + ".KML"
    pdot% = INSTR(f2$ , ".") - 1
    f3$ =  LEFT$(f2$, pdot%) + ".CSV"           'Re extract the file name to make the .CSV

    COLOR 5
    PRINT "Will generate  ";f2$; " And  ";f3$
    COLOR 7
    OPEN f2$ FOR OUTPUT AS #2
    OPEN f3$ FOR OUTPUT AS #3
    PRINT #3,"Time, Lat , Long"         'Dead simple .CSV header info
  '-----------------------------------------------------------------------

        PRINT
        PRINT "Press [esc] to finish"
        PRINT
        DO
 '           tim$ = TIME$
 '           se% = VAL(RIGHT$(tim$, 2))
            ik$ = INKEY$
            IF ik$ = CHR$(27) THEN EXIT LOOP    'Quick get out

  '..................................

    ' Start listening to the UDP/IP port
            ERRCLEAR
            UDP RECV #hUdp, FROM ipAddr, ipPor&, Buffer

        ' Ignore any timout or other errors
            IF ERR THEN ITERATE

        ' We got one, so update the status screen
            'PRINT "Received from " + DottedIP(ipAddr) + ":" + FORMAT$(ipPort) + " at " + TIME$

            pl$ = MID$(Buffer, 9)   'Extract the payload data
            mtype% = CVL(STRREVERSE$(MID$(pl$, 1 , 4)))

            IF mtype% = 2 THEN      'Extract the decoded message
                LenID% =  CVL(STRREVERSE$(MID$(pl$, 5 , 4)))        'Should be "WSJT-X" but lets generalise things here
                id$ = MID$(pl$ , 9, LenID%)

                        'Subsidiary info, decoded for the record but not reported
                seconds& =  CVL(STRREVERSE$(MID$(pl$ , 10 + LenID% , 4))) / 1000
                SNR& = CVL(STRREVERSE$(MID$(pl$ , 14 + LenID% , 4)))
                Dtime# = CVD(STRREVERSE$(MID$(pl$ , 18 + LenID% , 8)))
                Freq& =CVL(STRREVERSE$(MID$(pl$ , 26 + LenID% , 4)))

                lenmode% = CVL(STRREVERSE$(MID$(pl$, 30 + LenID% , 4)))
                md$ = MID$(pl$ , 34+ LenID%, Lenmode%)

                lenmsg% = CVL(STRREVERSE$(MID$(pl$, 34 + LenID% + lenmode%, 4)))
                message$ = MID$(pl$ ,  34 + LenID% + lenmode% + 4)

                hour% = (seconds& \ 3600) MOD 60
                minutes% = (seconds& \ 60) MOD 60
                tim$ = FORMAT$(hour% , "00") + ":" + FORMAT$(minutes% , "00")

                IF MID$(Message$ , 7 , 1)   = "-"  THEN           ' valid message
                    CALL DecodeAndWriteFile(tim$,SNR&,Dtime#,Freq&, Message$)     'Does the write to file and the starting stuff then  position data
                ELSE
                    COLOR 3
                    PRINT Message$
                END IF
            END IF      'Message type 2 found
       LOOP UNTIL ik$ = CHR$(27)

    CALL KmlFinish(lon#,lat#)      'Writes the terminating lines
    CLOSE 2
    CLOSE 3
    PRINT "KML and .CSV File generation terminated ";

    CommandSpec$ = ENVIRON$("comspec")
    'WndStyle& = 1
  '  CommandLine$ = "copy " + f2$ + " " + CHR$(34) + "%userprofile%\Desktop" + CHR$(34)
  '  SHELL CommandSpec$ & " /C " & CommandLine$, 1&

    PRINT : COLOR 11
    PRINT  f2$ + " Has been generated in the WSJT folder."
  '  print "A copy was placed on the Desktop"
    PRINT "Use  'Open With Google Earth' to view"
    PRINT
    PRINT  f3$ + " Has been generated in the WSJT folder. "
    COLOR 7
    PRINT "Any key to close this window..."

    WHILE NOT INSTAT : WEND
END FUNCTION
'-------------------------------------------------

'-------------------------------------------------
SUB DecodeAndWriteFile (tim$,SNR&,Dtime#,Freq&, Message$)

    STATIC FirstPass%

    NBase% = 25
    NegThresh% = 12

    la& = ASC(MID$(Message$ , 1 , 1))-65
    IF la& >= NegThresh% THEN la& = la& - NegThresh%
    la& = NBase% * la& + ASC(MID$(Message$ , 2 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 3 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 4 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 5 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 6 , 1))-65

    LatDeg& = INT(la& / 600000)
    LatMin# = (la& - LatDeg& * 600000) / 10000
    Lat# = LatDeg& + LatMin# / 60
    IF ASC(MID$(Message$, 1, 1)) - 65 >= NegThresh% THEN Lat# = -Lat#

    IF latdeg& > 90 THEN EXIT SUB                   'Bodged way of trapping out the false codes generted
                                                            '   Remove when that is sorted
    la& = ASC(MID$(Message$ , 8 , 1))-65
    IF la& >= NegThresh% THEN la& = la& - NegThresh%
    la& = NBase% * la& + ASC(MID$(Message$ , 9 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 10 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 11 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 12 , 1))-65
    la& = NBase% * la& + ASC(MID$(Message$ , 13 , 1))-65

    LonDeg& = INT(la& / 600000)
    LonMin# = (la& - LonDeg& * 600000) / 10000
    Lon# = LonDeg& + LonMin# / 60
    IF ASC(MID$(Message$, 8, 1)) - 65 >= NegThresh% THEN Lon# = -Lon#

    CALL GenNGR(Lat#, Lon#, ngr$)
    COLOR 6
    PRINT USING$("\   \  \           \   +##.##### +###.#####  \        \   ###dB #.##s #####Hz",tim$ , Message$, lat#,lon#, NGR$,SNR&,Dtime#,Freq&)
    COLOR 7
    IF NOT FirstPass% THEN CALL KmlStart(lon#, lat#) : firstpass% = -1       'Sets START coordinate
    PRINT #2,USING$("      +###.#####,+##.#####",lon#,lat#) 'Required RELATIVE height mode to be set
    PRINT #3,USING$("\    \, +00.#####, +000.#####",tim$,lat#,lon#)
END SUB

'------------------------------------------------------

SUB GenNGR(k#, l#, ngr$)
    DEFDBL a - z
    dr = 180 / 3.141592653589
    Ndiv% = 100
    Ndigits% = 3

     'first convert lat/long to northing / easting

    IF k < 49 OR k > 61 OR l < -8 OR l > 1.8 THEN
        ngr$ = ""
        EXIT SUB
    END IF
    a1 = 6377563.396 * 0.9996012717
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k3 = (k - 49) / dr
    k4 = (k + 49) / dr
    k1 = k / dr
    j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
    j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
    j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
    j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
    m = b1 * (j3 - j4 + j5 - j6)
    v = a1 / SQR(1 - e2 * SIN(k1) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k1) ^ 2)
    h2 = v / r - 1

    p = (l + 2) / dr
    j3 = m - 100000
    j4 = v / 2 * SIN(k1) * COS(k1)
    j5 = v / 24 * SIN(k1) * COS(k1) ^ 3 * (5 - TAN(k1) ^ 2 + 9 * h2)
    j6 = v / 720 * SIN(k1) * COS(k1) ^ 5 * (61 - 58 * TAN(k) ^ 2 + TAN(k1) ^ 4)
    n = j3 + p ^ 2 * j4 + p ^ 4 * j5 + p ^ 6 * j6

    j7 = v * COS(k1)
    j8 = v / 6 * COS(k1) ^ 3 * (v / r - TAN(k1) ^ 2)
    j9 = v / 120 * COS(k1) ^ 5
    j9 = j9 * (5 - 18 * TAN(k1) ^ 2 + TAN(k1) ^ 4 + 14 * h2 - 58 * TAN(k1) ^ 2 * h2)
    e = 400000 + p * j7 + p ^ 3 * j8 + p ^ 5 * j9

    'convert EN to NGR

    IF e <= 0 OR e > 700000# OR n <= 0 OR n > 1400000# THEN ngr$ = "Not valid": EXIT SUB

    easting1% = e \ 100000
    northing1% = n \ 100000
    C1% = 83 - 5 * (northing1% \ 5) + (easting1% \ 5)
    IF C1% = 73 THEN C1% = 72
    eh% = (easting1% MOD 5)
    nh% = (northing1% MOD 5)
    C2% = (4 - nh%) * 5 + eh% + 65
    IF C2% > 72 THEN C2% = C2% + 1
    easting2& = (e - easting1% * 100000) / Ndiv%
    northing2& = (n - northing1% * 100000) / Ndiv%
    CE$ = MID$(STR$(easting2&), 2)
    DO WHILE LEN(CE$) < Ndigits%
        CE$ = "0" + CE$
    LOOP
    CN$ = MID$(STR$(northing2&), 2)
    DO WHILE LEN(CN$) < Ndigits%
        CN$ = "0" + CN$
    LOOP
    ngr$ = CHR$(C1%) + CHR$(C2%) + CE$ + CN$

END SUB

'----------------------------
SUB KmlStart(startlon#,startlat#)
PRINT #2, "<?xml version=" & CHR$(34) & "1.0" & CHR$(34)& " encoding=" & CHR$(34)& "UTF-8" & CHR$(34)& "?>"     'Must start in Column 1
PRINT #2, "<kml xmlns=" & CHR$(34) & "http://www.opengis.net/kml/2.2" & CHR$(34) & ">"
PRINT #2, " <Document>
PRINT #2, "      <name>Paths</name>
PRINT  #2,"      <description>Path</description>
PRINT #2, "      <Style id=" & CHR$(34) & "yellowLineGreenPoly" & CHR$(34) & ">"
PRINT #2, "        <LineStyle>
PRINT  #2,"          <color>ffff00ff</color>
PRINT  #2,"          <width>6</width>
PRINT  #2,"        </LineStyle>
PRINT  #2,"       </Style>

PRINT  #2,"  <Placemark>
PRINT  #2,"      <name>Start</name>
PRINT  #2,"      <description>Start</description>
PRINT  #2,"      <Point>
PRINT  #2,"      <coordinates>

PRINT #2,USING$("      +###.#####,+##.#####",startlon#,startlat#)

PRINT  #2,"      </coordinates>
PRINT  #2,"      </Point>
PRINT  #2,"  </Placemark>

PRINT  #2,"  <Placemark>
PRINT  #2,"    <name>

PRINT  #2,"    </name>
PRINT  #2,"    <styleUrl>#yellowLineGreenPoly</styleUrl>
PRINT  #2,"    <LineString>
PRINT  #2,"    <altitudeMode>clampToGround</altitudeMode>
PRINT  #2,"     <coordinates>

END SUB
'-----------------------
SUB KmlFinish(endlon#,endlat#)       'Relies on #3 still being open from KmlStart
PRINT  #2,"        </coordinates>
PRINT  #2,"     </LineString>
PRINT  #2,"   </Placemark>


PRINT  #2,"  <Placemark>
PRINT  #2,"      <name>End</name>
PRINT  #2,"      <description>End</description>
PRINT  #2,"      <Point>
PRINT  #2,"      <coordinates>

PRINT #2,USING$("      +###.#####,+##.#####",endlon#,endlat#)

PRINT  #2,"      </coordinates>
PRINT  #2,"      </Point>
PRINT  #2,"  </Placemark>



PRINT  #2, "   </Document>
PRINT  #2,"   </kml>

END SUB
